﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using bookstore.Data;
using System.Data.Objects;
using System.Runtime.Remoting.Contexts;

namespace bookstore.ServicesREST
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the class name "BookstoreREST" in code, svc and config file together.
    public class BookstoreREST : IBookstoreREST
    {
        private ObjectContext objectContext;
        private ObjectSet<Book> bookSet;
        private ObjectSet<User> userSet;

        public BookstoreREST() : this(new bookstoreContainer()) { }

        public BookstoreREST(ObjectContext objectContext)
        {
            this.objectContext = objectContext;
            this.bookSet = objectContext.CreateObjectSet<Book>();
            this.userSet = objectContext.CreateObjectSet<User>();
        }

        public Book[] GetBooks()
        {
            IQueryable<Book> q = from b in bookSet select b;
            return q.ToArray<Book>();
        }

        public Book SearchBook(String title)
        {
            IQueryable<Book> q = from b in bookSet where b.Title.Equals(title) select b;
            return q.FirstOrDefault();
        }

        public int GetBookPrice(String title)
        {
            IQueryable<Book> q = from b in bookSet where b.Title.Equals(title) select b;
            return (int)q.FirstOrDefault().Price;
        }

        public String buyBook(String username, String title)
        {
            try
            {
                IQueryable<Book> book = from b in bookSet where b.Title.Equals(title) select b;
                IQueryable<User> user = from u in userSet where u.Username.Equals(username) select u;
                book.FirstOrDefault().Users.Add(user.FirstOrDefault());
                objectContext.SaveChanges();
                return "Book order successfull!";
            }
            catch (Exception e)
            {
                return e.Message;
            }

        }

        public User[] GetUsers()
        {
            IQueryable<User> q = from u in userSet select u;
            return q.ToArray<User>();
        }

        public string SayHello()
        {
            return "hello";
        }
    }
}
