﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using bookstore.Data;
using System.ServiceModel.Web;

namespace bookstore.ServicesREST
{
    // NOTE: You can use the "Rename" command on the "Refactor" menu to change the interface name "IBookstoreREST" in both code and config file together.
    [ServiceContract]
    [ServiceKnownType("GetKnownTypes", typeof(DataHelper))]
    public interface IBookstoreREST
    {
        [OperationContract(Name = "GetBooks")]
        [WebGet(UriTemplate = "/books")]
        Book[] GetBooks();

        [OperationContract(Name = "SearchBook")]
        [WebGet(UriTemplate = "/books/search/{title}")]
        Book SearchBook(String title);

        [OperationContract(Name = "GetBookPrice")]
        [WebGet(UriTemplate = "/books/price/{title}", ResponseFormat = WebMessageFormat.Json)]
        int GetBookPrice(String title);
        
        [OperationContract(Name = "BuyBook")]
        [WebInvoke(UriTemplate = "/buyBook/{username}/{bookTitle}", Method = "POST", ResponseFormat = WebMessageFormat.Json)]
        String buyBook(String username, String bookTitle);

        [OperationContract(Name = "GetUsers")]
        [WebGet(UriTemplate = "/users")]
        User[] GetUsers();

        [OperationContract(Name = "SayHello")]
        [WebGet(UriTemplate = "/")]
        string SayHello();
    }
}