package hu.bme.mit.szolgint.osgi.demo;

import hu.bme.mit.szolgint.osgi.demo.entities.Book;

import java.util.Collection;
import java.util.List;

public interface IBookManager {

	/**
	 * Creates a book in the database with title and price.
	 * 
	 * @param title
	 * @param price
	 */
	public void createBook(String title, int price, long authorId);

	/**
	 * Returns the book collection currently found in the database.
	 * 
	 * @return a collection of books.
	 */
	public Collection<Book> getBooks();
	
	public void deleteBook(long bookId);
	
	/**
	 * User with username buys the Book registered with bookId.
	 * @param username
	 * @param bookId
	 */
	public void buyBook(String username, long bookId);
	
	public List<Book> searchBook(String searchTitle);

}