package hu.bme.mit.szolgint.osgi.demo;

import hu.bme.mit.szolgint.osgi.demo.entities.User;
import hu.bme.mit.szolgint.osgi.demo.exceptions.BookStoreRuntimeException;

import java.util.List;

public interface IUserManager {

	/**
	 * Returns the registered user in the bookstore.
	 * 
	 * @return
	 * @throws BookStoreRuntimeException
	 */
	public abstract List<User> getUsers() throws BookStoreRuntimeException;

	/**
	 * Registers a user with the specified username. Throws an exception when
	 * the username is already taken by another User.
	 * 
	 * @param username
	 * @throws BookStoreRuntimeException
	 */
	public abstract void register(String username)
			throws BookStoreRuntimeException;

	/**
	 * Returns the User.
	 * 
	 * @param username
	 * @return
	 * @throws BookStoreRuntimeException
	 */
	public abstract User getUser(String username)
			throws BookStoreRuntimeException;

}