package hu.bme.mit.szolgint.osgi.demo.entities;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;

/**
 * Simple book entity.
 * 
 * @author Mark Czotter
 * 
 */
@Entity
@NamedQueries({
	@NamedQuery(name=Book.GET_BOOKS, query="SELECT b FROM Book b"), 
	@NamedQuery(name=Book.SEARCH_BOOK, query="SELECT b FROM Book b WHERE UPPER(b.title) LIKE :searchTitle")})
public class Book {

	public static final String GET_BOOKS = "GetBooks";
	public static final String SEARCH_BOOK = "SearchBook";
	
	@Id
	@Column(name = "BOOK_ID")
	@GeneratedValue
	private long id;
	private String title;
	private int price;

	@ManyToMany
	@JoinTable(name = "BOOK_AUTHOR", joinColumns = @JoinColumn(name = "BOOK_ID"), inverseJoinColumns = @JoinColumn(name = "AUTHOR_ID"))
	private List<Author> authors = new ArrayList<Author>();
	
	@ManyToMany(mappedBy="ownedBooks")
	private List<User> owners = new ArrayList<User>();

	public long getId() {
		return id;
	}

	public String getTitle() {
		return title;
	}

	public void setTitle(String title) {
		this.title = title;
	}

	public int getPrice() {
		return price;
	}

	public void setPrice(int price) {
		this.price = price;
	}
	
	public List<Author> getAuthors() {
		return authors;
	}
	
	public List<User> getOwners() {
		return owners;
	}
	
	public void setOwners(List<User> owners) {
		this.owners = owners;
	}

}
