package hu.bme.mit.szolgint.osgi.demo.entities;

import hu.bme.mit.szolgint.osgi.demo.exceptions.BookStoreRuntimeException;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class EntityManagerProvider {

	private final static EntityManagerFactory entityManagerFactory = Persistence
			.createEntityManagerFactory("osgi.demo.jpa");
	
	public static EntityManager getEntityManager() throws BookStoreRuntimeException {
		if (entityManagerFactory == null) {
			throw new BookStoreRuntimeException("Persistence factory error!");
		}
		EntityManager em = entityManagerFactory.createEntityManager();
		if (em == null) {
			throw new BookStoreRuntimeException("BookStore database cannot be resolved!");
		}
		return em;
	}
}
