package hu.bme.mit.szolgint.osgi.demo.entities;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.NamedQuery;
import javax.persistence.Table;

/**
 * Simple user entity.
 * 
 * @author Mark Czotter
 * 
 */
@Entity
@NamedQuery(name=User.GET_USERS, query="SELECT tu FROM User tu")
@Table(name="T_USER")
public class User {

	public static final String GET_USERS = "GetUsers";
	
	@Id
	private String username;
	
	@ManyToMany
	@JoinTable(name="USER_BOOKS", joinColumns=@JoinColumn(name="USERNAME"), inverseJoinColumns=@JoinColumn(name="BOOK_ID"))
	private List<Book> ownedBooks = new ArrayList<Book>();
	
	public String getUsername() {
		return username;
	}
	
	public void setUsername(String username) {
		this.username = username;
	}
	
	public List<Book> getOwnedBooks() {
		return ownedBooks;
	}
	
	public void setOwnedBooks(List<Book> books) {
		this.ownedBooks = books;
	}
	
}
