package hu.bme.mit.szolgint.osgi.demo.booktests;

import hu.bme.mit.szolgint.osgi.demo.entities.Book;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import javax.persistence.Query;

import junit.framework.Assert;

import org.junit.Before;
import org.junit.Test;

public class BookTest {

	public static final String PERSISTENT_UNIT = "osgi.demo.jpa";
	private EntityManagerFactory factory;
	
	@Before
	public void setUp() {
		factory = Persistence.createEntityManagerFactory(PERSISTENT_UNIT);
		EntityManager em = factory.createEntityManager();
		
		em.getTransaction().begin();
		
		Query query = em.createNamedQuery(Book.GET_BOOKS);
		if (query.getResultList().size() == 0) {
			for (int i = 0; i < 10; i++) {
				Book b = new Book();
				b.setTitle("Title" + i);
				b.setPrice(i * 100);
				em.persist(b);
			}
		}
		em.getTransaction().commit();
		em.close();
	}
	
	@Test
	public void simpleTest() {
		EntityManager em = factory.createEntityManager();
		Assert.assertEquals(10, em.createNamedQuery(Book.GET_BOOKS).getResultList().size());
		em.close();
	}
	
}
