package hu.bme.mit.bookorder;

import hu.bme.mit.bookorder.handlers.BuyBookWorkItemHandler;
import hu.bme.mit.bookorder.handlers.CheckPriceInvocationWorkItemHandler;

import org.drools.KnowledgeBase;
import org.drools.builder.KnowledgeBuilder;
import org.drools.builder.KnowledgeBuilderFactory;
import org.drools.builder.ResourceType;
import org.drools.io.ResourceFactory;
import org.drools.runtime.StatefulKnowledgeSession;

public class ProcessMain {
	public static void main(String[] args) throws Exception {
		KnowledgeBase kbase = readKnowledgeBase();
		StatefulKnowledgeSession ksession = kbase.newStatefulKnowledgeSession();
		
		ksession.getWorkItemManager().registerWorkItemHandler("CheckPriceInvocation", new CheckPriceInvocationWorkItemHandler());
		ksession.getWorkItemManager().registerWorkItemHandler("BuyBook", new BuyBookWorkItemHandler());
		
		ksession.startProcess("hu.bme.mit.wf.bookorder");
	}

	private static KnowledgeBase readKnowledgeBase() throws Exception {
		KnowledgeBuilder kbuilder = KnowledgeBuilderFactory.newKnowledgeBuilder();
		kbuilder.add(ResourceFactory.newClassPathResource("bookorder.bpmn"), ResourceType.BPMN2);
		return kbuilder.newKnowledgeBase();
	}
}
