package hu.bme.mit.bookorder.handlers;

import java.util.HashMap;
import java.util.Map;

import org.drools.process.instance.WorkItemHandler;
import org.drools.runtime.process.WorkItem;
import org.drools.runtime.process.WorkItemManager;

import com.sun.jersey.api.client.Client;
import com.sun.jersey.api.client.WebResource;

public class CheckPriceInvocationWorkItemHandler implements WorkItemHandler {

	@Override
	public void abortWorkItem(WorkItem wi, WorkItemManager wim) {
		// TODO Auto-generated method stub

	}

	@Override
	public void executeWorkItem(WorkItem wi, WorkItemManager wim) {
		String address = (String) wi.getParameter("URL");
		String message = (String) wi.getParameter("Message");
		String method = (String) wi.getParameter("Method");

		System.out.println("Calling WS @" + address + message + " - method: "
				+ method);

		try {
			Client client = Client.create();
			WebResource webResource = client.resource(address + message);
			String ret = "";
			
			if(method.equalsIgnoreCase("GET")){
				System.out.println("Executing via GET...");
				ret = webResource.get(String.class);
			}
			else if(method.equalsIgnoreCase("PUT")){
				System.out.println("Executing via PUT...");
				ret = webResource.put(String.class);
			}
			else if(method.equalsIgnoreCase("POST")){
				System.out.println("Executing via POST...");
				ret = webResource.post(String.class);
			}
			
			int price = Integer.parseInt(ret);
			
			Map<String, Object> results = new HashMap<String, Object>();
			results.put("price", price);
			
			wim.completeWorkItem(wi.getId(), results);
			
		} catch (Exception e) {
			e.printStackTrace();
			wim.completeWorkItem(wi.getId(), null);
		}
		
		
	}
}
